//
#property copyright "Modified LexLampard 2016" 
#property link      ""
//#property strict
//
//
extern bool   Anti_Ilan_Mode      = false;  //  
extern double General_Profit      = 150;
extern bool   TradeSell           = true;   // true     Sell, false     Buy
extern bool   Open_before_closing = false;  //           
extern double LotExponent         = 1.4;    //        . :   0.1, : 0.16, 0.26, 0.43 ...
extern bool   DynamicPips         = true; 
extern int    DefaultPips         = 12;
extern int    Glubina             = 24;
extern int    DEL                 = 3;
extern double slip                = 3.0;    //            (     )
extern double Lots                = 0.01;   //     
int    lotdecimal;                          // 
extern double TakeProfit          = 10.0;   //       
//extern double PipStep = 30.0;             //     
extern double Drop                = 500;
extern double RsiMinimum          = 30.0;   //   RSI
extern double RsiMaximum          = 70.0;   //   RSI
extern int    MagicNumber         = 2222;   //   (      )
int PipStep=0;
//
extern int    MaxTrades           = 10;     //     
extern bool   UseEquityStop       = FALSE;
extern double TotalEquityRisk     = 20.0;
extern bool   UseTrailingStop     = FALSE;
extern double Stoploss            = 500.0;  //  
extern double TrailStart          = 10.0;
extern double TrailStop           = 10.0;
extern bool   UseTimeOut          = FALSE;  //   (    ""  )
extern double MaxTradeOpenHours   = 48.0;   //      (    )
extern int    ButtonX             = 100;
extern int    ButtonY             = 15;
extern int    ButtonCorner        = 1;
//
double PriceTarget, StartEquity, BuyTarget, SellTarget;
double AveragePrice, SellLimit, BuyLimit;
double LastBuyPrice, LastSellPrice, Spread;
bool flag;
string EAName="Ilan1.6_Anti_Ilan_LLm";
int timeprev = 0, expiration;
int NumOfTrades = 0;
double iLots;
int cnt = 0, total;
double Stopper = 0.0;
bool TradeNow = FALSE, LongTrade = FALSE, ShortTrade = FALSE;
int ticket;
bool  NewOrdersPlaced = FALSE;
double AccountEquityHighAmt, PrevEquity;
bool errororder = TRUE;
double current_profit;
int type;
bool at;
string GetTXT;
bool AllSymbol = false;
//
int init() {
//--- LotDecimal
   lotdecimal = (int)(MathLog(1/MarketInfo(Symbol(),MODE_LOTSTEP))/MathLog(10));
   Spread = MarketInfo(Symbol(), MODE_SPREAD) * Point;
   ButtonBS();
   ButtonCloseAll();
   if(TradeSell) at = true;
   if(at) 
    {
     ObjectSetText("ButtonBuySell","Sell");
     ObjectSetInteger(0,"ButtonBuySell",OBJPROP_BGCOLOR,clrRed);
    }
   else
    {
     ObjectSetText("ButtonBuySell","Buy");
     ObjectSetInteger(0,"ButtonBuySell",OBJPROP_BGCOLOR,clrDodgerBlue);
    }
  return (0);
}

int deinit() {
   ButtonDelete(0,"ButtonBuySell");
   ButtonDelete(0,"ButtonCloseAll");
   return (0);
}
//
int start()
 {
//---
      if(ObjectGetInteger(0,"ButtonBuySell",OBJPROP_STATE,true))
       { 
         if(!at)
         {
         ObjectSetText("ButtonBuySell","Sell");
         TradeSell  = true;
         //ShortTrade = true;
         //LongTrade  = false;
         at=true;
         ObjectSetInteger(0,"ButtonBuySell",OBJPROP_STATE,false);
         ObjectSetInteger(0,"ButtonBuySell",OBJPROP_BGCOLOR,clrRed);
         }
      if(ObjectGetInteger(0,"ButtonBuySell",OBJPROP_STATE,true))
       {
         if(at)
         {
         ObjectSetText("ButtonBuySell","Buy");
         TradeSell  = false;
         //LongTrade  = true;
         //ShortTrade = false;
         at=false;
         ObjectSetInteger(0,"ButtonBuySell",OBJPROP_STATE,false);
         ObjectSetInteger(0,"ButtonBuySell",OBJPROP_BGCOLOR,clrDodgerBlue);
         }
       }
         
       }
//---
      if(ObjectGetInteger(0,"ButtonCloseAll",OBJPROP_STATE,true))
       { CloseAll();
         ObjectSetInteger(0,"ButtonCloseAll",OBJPROP_STATE,false);
       }
//---
       GetTXT = ObjectGetString(0,"ButtonBuySell",OBJPROP_TEXT);
//---
 int i;
   if(General_Profit>0 && Anti_Ilan_Mode) {
      current_profit=0;
      for(i=OrdersTotal()-1;i>=0;i--) if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES) && OrderSymbol()==Symbol() && OrderMagicNumber()==MagicNumber) {
         current_profit+=OrderProfit()+OrderSwap()+OrderCommission();
         }
      if(current_profit>=General_Profit) {
         CloseThisSymbolAll();
         return(0);
         }
      }   
//---
 if (DynamicPips)  {
     double hival=High[iHighest(NULL,0,MODE_HIGH,Glubina,1)];    // calculate highest and lowest price from last bar to 24 bars ago
     double loval=Low[iLowest(NULL,0,MODE_LOW,Glubina,1)];       // chart used for symbol and time period
     PipStep=NormalizeDouble((hival-loval)/DEL/Point,0);         // calculate pips for spread between orders
     if (PipStep<DefaultPips/DEL) PipStep = NormalizeDouble(DefaultPips/DEL,0);
     if (PipStep>DefaultPips*DEL) PipStep = NormalizeDouble(DefaultPips*DEL,0);          // if dynamic pips fail, assign pips extreme value
   }// else PipStep = DefaultPips;
   //double filtr_MA = iMA(NULL,60,60,0,0,0,0);
   if (UseTimeOut) {
      if (TimeCurrent() >= expiration) {
         CloseThisSymbolAll();
         Print("Closed All due to TimeOut");

      }
   }
   
   double PrevCl;
   double CurrCl;
   if (UseTrailingStop) TrailingAlls(TrailStart, TrailStop, AveragePrice);
   if ((iCCI(NULL,15,55,0,0)>Drop && ShortTrade)||(iCCI(NULL,15,55,0,0)<(-Drop) && LongTrade)) {
      
         CloseThisSymbolAll();
         Print("Closed All due to TimeOut");
     
   }
   if (timeprev == Time[0]) return (0);
   timeprev = Time[0];
   
   double CurrentPairProfit = CalculateProfit();
   if (UseEquityStop) {
      if (CurrentPairProfit < 0.0 && MathAbs(CurrentPairProfit) > TotalEquityRisk / 100.0 * AccountEquityHigh()) {
         CloseThisSymbolAll();
         Print("Closed All due to Stop Out");
         NewOrdersPlaced = FALSE;
      }
   }
   total = CountTrades();
   if (total == 0) flag = FALSE;
   for (cnt = OrdersTotal() - 1; cnt >= 0; cnt--) {
      errororder = OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if (OrderSymbol() != Symbol() || OrderMagicNumber() != MagicNumber) continue;
      if (OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber) {
         if (OrderType() == OP_BUY) {
           if(Open_before_closing){
            if(GetTXT == "Buy")
            {
             LongTrade  = TRUE;
             ShortTrade = FALSE;
             break;
            }
            if(GetTXT == "Sell")
            {
             LongTrade  = FALSE;
             ShortTrade = TRUE;
             TradeNow   = TRUE;
             break;
            }
          }
          else {
           LongTrade  = TRUE;
           ShortTrade = FALSE;
           break;
          }
         }
      }
      if (OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber) {
         if (OrderType() == OP_SELL) {
           if(Open_before_closing){
            if(GetTXT == "Buy")
            {
             LongTrade  = TRUE;
             ShortTrade = FALSE;
             TradeNow   = TRUE;
             break;
            }
            if(GetTXT == "Sell")
            {
             LongTrade  = FALSE;
             ShortTrade = TRUE;
             break;
            }
           }
           else {
            LongTrade  = FALSE;
            ShortTrade = TRUE;
            break;
           }
         }
      }
   }
   if (total > 0 && total <= MaxTrades) {
      RefreshRates();
      LastBuyPrice = FindLastBuyPrice();
      LastSellPrice = FindLastSellPrice();
      //if (LongTrade && LastBuyPrice - Ask >= PipStep * Point) TradeNow = TRUE;
      //if (ShortTrade && Bid - LastSellPrice >= PipStep * Point) TradeNow = TRUE;
      if(Anti_Ilan_Mode==true){
         if (LongTrade &&  Ask - LastBuyPrice >= PipStep * Point) TradeNow = TRUE;
         if (ShortTrade && LastSellPrice - Bid >= PipStep * Point) TradeNow = TRUE;
      }
      if(Anti_Ilan_Mode==false){
         if (LongTrade && LastBuyPrice - Ask >= PipStep * Point) TradeNow = TRUE;
         if (ShortTrade && Bid - LastSellPrice >= PipStep * Point) TradeNow = TRUE;
      }
   }
   if (total < 1) {
      ShortTrade = FALSE;
      LongTrade = FALSE;
      TradeNow = TRUE;
      StartEquity = AccountEquity();
   }
   if (TradeNow) {
      LastBuyPrice = FindLastBuyPrice();
      LastSellPrice = FindLastSellPrice();
      if (ShortTrade) {
         NumOfTrades = total;
         iLots = NormalizeDouble(Lots * MathPow(LotExponent, NumOfTrades), lotdecimal);
         RefreshRates();
         ticket = OpenPendingOrder(1, iLots, Bid, slip, Ask, 0, 0, EAName + "-" + NumOfTrades + "-" + PipStep, MagicNumber, 0, HotPink);
         if (ticket < 0) {
            Print("Error: ", GetLastError());
            return (0);
         }
         LastSellPrice = FindLastSellPrice();
         TradeNow = FALSE;
         NewOrdersPlaced = TRUE;
      } else {
         if (LongTrade) {
            NumOfTrades = total;
            iLots = NormalizeDouble(Lots * MathPow(LotExponent, NumOfTrades), lotdecimal);
            ticket = OpenPendingOrder(0, iLots, Ask, slip, Bid, 0, 0, EAName + "-" + NumOfTrades + "-" + PipStep, MagicNumber, 0, Lime);
            if (ticket < 0) {
               Print("Error: ", GetLastError());
               return (0);
            }
            LastBuyPrice = FindLastBuyPrice();
            TradeNow = FALSE;
            NewOrdersPlaced = TRUE;
         }
      }
   }
   if (TradeNow && total < 1) {
      PrevCl = iClose(Symbol(), 0, 2);
      CurrCl = iClose(Symbol(), 0, 1);
      SellLimit = Bid;
      BuyLimit = Ask;
      if (!ShortTrade && !LongTrade && Anti_Ilan_Mode==false) {
         NumOfTrades = total;
         iLots = NormalizeDouble(Lots * MathPow(LotExponent, NumOfTrades), lotdecimal);
         if (TradeSell) {
         //if (PrevCl > CurrCl) {
            if (iRSI(NULL, PERIOD_H1, 14, PRICE_CLOSE, 1) > RsiMinimum ) {
               ticket = OpenPendingOrder(1, iLots, SellLimit, slip, SellLimit, 0, 0, EAName + "-" + IntegerToString(NumOfTrades), MagicNumber, 0, HotPink);
               if (ticket < 0) {
                  Print("Error: ", GetLastError());
                  return (0);
               }
               LastBuyPrice = FindLastBuyPrice();
               NewOrdersPlaced = TRUE;
            }
         } else {
            if (iRSI(NULL, PERIOD_H1, 14, PRICE_CLOSE, 1) < RsiMaximum ) {
               ticket = OpenPendingOrder(0, iLots, BuyLimit, slip, BuyLimit, 0, 0, EAName + "-" + IntegerToString(NumOfTrades), MagicNumber, 0, Lime);
               if (ticket < 0) {
                  Print("Error: ", GetLastError());
                  return (0);
               }
               LastSellPrice = FindLastSellPrice();
               NewOrdersPlaced = TRUE;
            }
         }
         if (ticket > 0 && UseTimeOut) expiration = TimeCurrent() + 60.0 * (60.0 * MaxTradeOpenHours);
         TradeNow = FALSE;
      }
      
         if (!ShortTrade && !LongTrade && Anti_Ilan_Mode==true && CountTrades() < 1/* && OrdersHistoryTotal()<=0*/) {
         NumOfTrades = total;
         iLots = NormalizeDouble(Lots * MathPow(LotExponent, NumOfTrades), lotdecimal);
         if (TradeSell) {
         //if (PrevCl > CurrCl) {
            if (iRSI(NULL, PERIOD_H1, 14, PRICE_CLOSE, 1) > RsiMinimum ) {
               ticket = OpenPendingOrder(1, iLots, SellLimit, slip, SellLimit, 0, 0, EAName + "-" + IntegerToString(NumOfTrades), MagicNumber, 0, HotPink);
               if (ticket < 0) {
                  Print("Error: ", GetLastError());
                  return (0);
               }
               LastBuyPrice = FindLastBuyPrice();
               NewOrdersPlaced = TRUE;
            }
         } else {
            if (iRSI(NULL, PERIOD_H1, 14, PRICE_CLOSE, 1) < RsiMaximum ) {
               ticket = OpenPendingOrder(0, iLots, BuyLimit, slip, BuyLimit, 0, 0, EAName + "-" + IntegerToString(NumOfTrades), MagicNumber, 0, Lime);
               if (ticket < 0) {
                  Print("Error: ", GetLastError());
                  return (0);
               }
               LastSellPrice = FindLastSellPrice();
               NewOrdersPlaced = TRUE;
            }
         }
         if (ticket > 0 && UseTimeOut) expiration = TimeCurrent() + 60.0 * (60.0 * MaxTradeOpenHours);
         TradeNow = FALSE;
      }
      
      if (!ShortTrade && !LongTrade && Anti_Ilan_Mode==true && CountTrades() < 1/* && OrdersHistoryTotal()>0*/) {
         NumOfTrades = total;
         iLots = NormalizeDouble(Lots * MathPow(LotExponent, NumOfTrades), lotdecimal);
         if (TradeSell) {
         for(i=0;i<=OrdersHistoryTotal();i++){         
            errororder = OrderSelect(i,SELECT_BY_POS,MODE_HISTORY);
            if(OrderSymbol()==Symbol() && OrderMagicNumber()==MagicNumber){
               type=OrderType();
            }
         }
         if(type==OP_BUY){
            //ticket = OpenPendingOrder(0, iLots, BuyLimit, slip, BuyLimit, 0, 0, EAName + "-" + IntegerToString(NumOfTrades), MagicNumber, 0, Lime);
            if (ticket < 0) {
               Print("Error: ", GetLastError());
               return (0);
            }
            LastSellPrice = FindLastSellPrice();
            NewOrdersPlaced = TRUE;                       
         }
         if(type==OP_SELL){
            ticket = OpenPendingOrder(1, iLots, SellLimit, slip, SellLimit, 0, 0, EAName + "-" + IntegerToString(NumOfTrades), MagicNumber, 0, HotPink);
            if (ticket < 0) {
               Print("Error: ", GetLastError());
               return (0);
            }
            LastBuyPrice = FindLastBuyPrice();
            NewOrdersPlaced = TRUE;
         }
         if (ticket > 0 && UseTimeOut) expiration = TimeCurrent() + 60.0 * (60.0 * MaxTradeOpenHours);
         TradeNow = FALSE; 
         }
        }
      }
   total = CountTrades();
   AveragePrice = 0;
   double Count = 0;
   for (cnt = OrdersTotal() - 1; cnt >= 0; cnt--) {
      errororder = OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if (OrderSymbol() != Symbol() || OrderMagicNumber() != MagicNumber) continue;
      if (OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber) {
         if (OrderType() == OP_BUY || OrderType() == OP_SELL) {
            AveragePrice += OrderOpenPrice() * OrderLots();
            Count += OrderLots();
         }
      }
   }
   if (total > 0) AveragePrice = NormalizeDouble(AveragePrice / Count, Digits);
   if (NewOrdersPlaced) {
      for (cnt = OrdersTotal() - 1; cnt >= 0; cnt--) {
         errororder = OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
         if (OrderSymbol() != Symbol() || OrderMagicNumber() != MagicNumber) continue;
         if (OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber) {
            if (OrderType() == OP_BUY) {
               PriceTarget = AveragePrice + TakeProfit * Point;
               BuyTarget = PriceTarget;
               Stopper = AveragePrice - Stoploss * Point;
               flag = TRUE;
            }
         }
         if (OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber) {
            if (OrderType() == OP_SELL) {
               PriceTarget = AveragePrice - TakeProfit * Point;
               SellTarget = PriceTarget;
               Stopper = AveragePrice + Stoploss * Point;
               flag = TRUE;
            }
         }
      }
   }
   if (NewOrdersPlaced) {
      if (flag == TRUE) {
         for (cnt = OrdersTotal() - 1; cnt >= 0; cnt--) {
            errororder = OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
            if (OrderSymbol() != Symbol() || OrderMagicNumber() != MagicNumber) continue;
            if(Anti_Ilan_Mode==false){
               if (OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber) errororder = OrderModify(OrderTicket(), NormalizeDouble(AveragePrice,Digits), NormalizeDouble(OrderStopLoss(),Digits), NormalizeDouble(PriceTarget,Digits), 0, Yellow);
               NewOrdersPlaced = FALSE;
            }
            if(Anti_Ilan_Mode==true){
               if (OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber) errororder = OrderModify(OrderTicket(), NormalizeDouble(AveragePrice,Digits), NormalizeDouble(Stopper,Digits), NormalizeDouble(OrderTakeProfit(),Digits), 0, Yellow);
               NewOrdersPlaced = FALSE;
            }
         }
      }
   }
   return (0);
}
//

int CountTrades() {
   int count = 0;
   for (int trade = OrdersTotal() - 1; trade >= 0; trade--) {
      errororder = OrderSelect(trade, SELECT_BY_POS, MODE_TRADES);
      if (OrderSymbol() != Symbol() || OrderMagicNumber() != MagicNumber) continue;
      if (OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber)
         if (OrderType() == OP_SELL || OrderType() == OP_BUY) count++;
   }
   return (count);
}
//

void CloseThisSymbolAll() {
   for (int trade = OrdersTotal() - 1; trade >= 0; trade--) {
      errororder = OrderSelect(trade, SELECT_BY_POS, MODE_TRADES);
      if (OrderSymbol() == Symbol()) {
         if (OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber) {
            if (OrderType() == OP_BUY) errororder = OrderClose(OrderTicket(), OrderLots(), Bid, slip, Blue);
            if (OrderType() == OP_SELL) errororder = OrderClose(OrderTicket(), OrderLots(), Ask, slip, Red);
         }
         Sleep(1000);
      }
   }
}

//

int OpenPendingOrder(int pType, double pLots, double pLevel, int sp, double pr, int sl, int tp, string pComment, int pMagic, int pDatetime, color pColor) {
   int ticket2 = 0;
   int err = 0;
   int c = 0;
   int NumberOfTries = 100;
   switch (pType) {
   case 2:
      for (c = 0; c < NumberOfTries; c++) {
         ticket2 = OrderSend(Symbol(), OP_BUYLIMIT, pLots, pLevel, sp, StopLong(pr, sl), TakeLong(pLevel, tp), pComment, pMagic, pDatetime, pColor);
         err = GetLastError();
         if (err == 0/* NO_ERROR */) break;
         if (!(err == 4/* SERVER_BUSY */ || err == 137/* BROKER_BUSY */ || err == 146/* TRADE_CONTEXT_BUSY */ || err == 136/* OFF_QUOTES */)) break;
         Sleep(1000);
      }
      break;
   case 4:
      for (c = 0; c < NumberOfTries; c++) {
         ticket2 = OrderSend(Symbol(), OP_BUYSTOP, pLots, pLevel, sp, StopLong(pr, sl), TakeLong(pLevel, tp), pComment, pMagic, pDatetime, pColor);
         err = GetLastError();
         if (err == 0/* NO_ERROR */) break;
         if (!(err == 4/* SERVER_BUSY */ || err == 137/* BROKER_BUSY */ || err == 146/* TRADE_CONTEXT_BUSY */ || err == 136/* OFF_QUOTES */)) break;
         Sleep(5000);
      }
      break;
   case 0:
      for (c = 0; c < NumberOfTries; c++) {
         RefreshRates();
         ticket2 = OrderSend(Symbol(), OP_BUY, pLots, NormalizeDouble(Ask,Digits), sp, NormalizeDouble(StopLong(Bid, sl),Digits), NormalizeDouble(TakeLong(Ask, tp),Digits), pComment, pMagic, pDatetime, pColor);
         err = GetLastError();
         if (err == 0/* NO_ERROR */) break;
         if (!(err == 4/* SERVER_BUSY */ || err == 137/* BROKER_BUSY */ || err == 146/* TRADE_CONTEXT_BUSY */ || err == 136/* OFF_QUOTES */)) break;
         Sleep(5000);
      }
      break;
   case 3:
      for (c = 0; c < NumberOfTries; c++) {
         ticket2 = OrderSend(Symbol(), OP_SELLLIMIT, pLots, pLevel, sp, StopShort(pr, sl), TakeShort(pLevel, tp), pComment, pMagic, pDatetime, pColor);
         err = GetLastError();
         if (err == 0/* NO_ERROR */) break;
         if (!(err == 4/* SERVER_BUSY */ || err == 137/* BROKER_BUSY */ || err == 146/* TRADE_CONTEXT_BUSY */ || err == 136/* OFF_QUOTES */)) break;
         Sleep(5000);
      }
      break;
   case 5:
      for (c = 0; c < NumberOfTries; c++) {
         ticket2 = OrderSend(Symbol(), OP_SELLSTOP, pLots, pLevel, sp, StopShort(pr, sl), TakeShort(pLevel, tp), pComment, pMagic, pDatetime, pColor);
         err = GetLastError();
         if (err == 0/* NO_ERROR */) break;
         if (!(err == 4/* SERVER_BUSY */ || err == 137/* BROKER_BUSY */ || err == 146/* TRADE_CONTEXT_BUSY */ || err == 136/* OFF_QUOTES */)) break;
         Sleep(5000);
      }
      break;
   case 1:
      for (c = 0; c < NumberOfTries; c++) {
         ticket2 = OrderSend(Symbol(), OP_SELL, pLots, NormalizeDouble(Bid,Digits), sp, NormalizeDouble(StopShort(Ask, sl),Digits), NormalizeDouble(TakeShort(Bid, tp),Digits), pComment, pMagic, pDatetime, pColor);
         err = GetLastError();
         if (err == 0/* NO_ERROR */) break;
         if (!(err == 4/* SERVER_BUSY */ || err == 137/* BROKER_BUSY */ || err == 146/* TRADE_CONTEXT_BUSY */ || err == 136/* OFF_QUOTES */)) break;
         Sleep(5000);
      }
   }
   return (ticket2);
}
//
double StopLong(double price, int stop) {
   if (stop == 0) return (0);
   else return (price - stop * Point);
}
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
double StopShort(double price, int stop) {
   if (stop == 0) return (0);
   else return (price + stop * Point);
}
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
double TakeLong(double price, int stop) {
   if (stop == 0) return (0);
   else return (price + stop * Point);
}
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
double TakeShort(double price, int stop) {
   if (stop == 0) return (0);
   else return (price - stop * Point);
}
//
double CalculateProfit() {
   double Profit = 0;
   for (cnt = OrdersTotal() - 1; cnt >= 0; cnt--) {
      errororder = OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if (OrderSymbol() != Symbol() || OrderMagicNumber() != MagicNumber) continue;
      if (OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber)
         if (OrderType() == OP_BUY || OrderType() == OP_SELL) Profit += OrderProfit();
   }
   return (Profit);
}
//
void TrailingAlls(int pType, int stop, double AvgPrice) {
   int profit;
   double stoptrade;
   double stopcal;
   if (stop != 0) {
      for (int trade = OrdersTotal() - 1; trade >= 0; trade--) {
         if (OrderSelect(trade, SELECT_BY_POS, MODE_TRADES)) {
            if (OrderSymbol() != Symbol() || OrderMagicNumber() != MagicNumber) continue;
            if (OrderSymbol() == Symbol() || OrderMagicNumber() == MagicNumber) {
               if (OrderType() == OP_BUY) {
                  profit = NormalizeDouble((Bid - AvgPrice) / Point, 0);
                  if (profit < pType) continue;
                  stoptrade = OrderStopLoss();
                  stopcal = Bid - stop * Point;
                  if (stoptrade == 0.0 || (stoptrade != 0.0 && stopcal > stoptrade)) errororder = OrderModify(OrderTicket(), AvgPrice, stopcal, OrderTakeProfit(), 0, Aqua);
               }
               if (OrderType() == OP_SELL) {
                  profit = NormalizeDouble((AvgPrice - Ask) / Point, 0);
                  if (profit < pType) continue;
                  stoptrade = OrderStopLoss();
                  stopcal = Ask + stop * Point;
                  if (stoptrade == 0.0 || (stoptrade != 0.0 && stopcal < stoptrade)) errororder = OrderModify(OrderTicket(), AvgPrice, stopcal, OrderTakeProfit(), 0, Red);
               }
            }
            Sleep(1000);
         }
      }
   }
}
//

double AccountEquityHigh() {
   if (CountTrades() == 0) AccountEquityHighAmt = AccountEquity();
   if (AccountEquityHighAmt < PrevEquity) AccountEquityHighAmt = PrevEquity;
   else AccountEquityHighAmt = AccountEquity();
   PrevEquity = AccountEquity();
   return (AccountEquityHighAmt);
}
//

double FindLastBuyPrice() {
   double oldorderopenprice;
   int oldticketnumber;
   double unused = 0;
   int ticketnumber = 0;
   for (int cnt2 = OrdersTotal() - 1; cnt2 >= 0; cnt2--) {
      errororder = OrderSelect(cnt2, SELECT_BY_POS, MODE_TRADES);
      if (OrderSymbol() != Symbol() || OrderMagicNumber() != MagicNumber) continue;
      if (OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber && OrderType() == OP_BUY) {
         oldticketnumber = OrderTicket();
         if (oldticketnumber > ticketnumber) {
            oldorderopenprice = OrderOpenPrice();
            unused = oldorderopenprice;
            ticketnumber = oldticketnumber;
         }
      }
   }
   return (oldorderopenprice);
}

double FindLastSellPrice() {
   double oldorderopenprice;
   int oldticketnumber;
   double unused = 0;
   int ticketnumber = 0;
   for (int cnt2 = OrdersTotal() - 1; cnt2 >= 0; cnt2--) {
      errororder = OrderSelect(cnt2, SELECT_BY_POS, MODE_TRADES);
      if (OrderSymbol() != Symbol() || OrderMagicNumber() != MagicNumber) continue;
      if (OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber && OrderType() == OP_SELL) {
         oldticketnumber = OrderTicket();
         if (oldticketnumber > ticketnumber) {
            oldorderopenprice = OrderOpenPrice();
            unused = oldorderopenprice;
            ticketnumber = oldticketnumber;
         }
      }
   }
   return (oldorderopenprice);
}
//---
//+------------------------------------------------------------------+
//|   Buy                                                  |
//+------------------------------------------------------------------+
bool ButtonBS    (const long              chart_ID=0,               // ID 
                  const string            name="ButtonBuySell",     //  
                  const int               sub_window=0,             //  
                  const int               x=0,                      //    X 10
                  const int               y=0,                      //    Y 30
                  const int               width=90,                 //  
                  const int               height=20,                //  
                  const ENUM_BASE_CORNER  corner=CORNER_LEFT_UPPER, //    
                  const string            text="",                  // 
                  const string            font="Verdana",           // 
                  const int               font_size=8,              //  
                  const color             clr=clrBlack,             //  
                  const color             back_clr=clrDodgerBlue,   //  
                  const color             border_clr=clrNONE,       //  
                  const bool              state=false,              // /
                  const bool              back=false,               //   
                  const bool              selection=false,          //   
                  const bool              hidden=true,              //    
                  const long              z_order=1)                //    
  {
//---   
   ResetLastError();
//---  
   if(!ObjectCreate(chart_ID,name,OBJ_BUTTON,sub_window,0,0))
     {
      //Print(__FUNCTION__,
      //      ":    !   = ",GetLastError());
      return(false);
     }
//---   
   ObjectSetInteger(chart_ID,name,OBJPROP_XDISTANCE,ButtonX);//100
   ObjectSetInteger(chart_ID,name,OBJPROP_YDISTANCE,ButtonY); //15
//---   
   ObjectSetInteger(chart_ID,name,OBJPROP_XSIZE,width);
   ObjectSetInteger(chart_ID,name,OBJPROP_YSIZE,height);
//---   ,      
   ObjectSetInteger(chart_ID,name,OBJPROP_CORNER,ButtonCorner);
//---  
   ObjectSetString(chart_ID,name,OBJPROP_TEXT,text);
//---   
   ObjectSetString(chart_ID,name,OBJPROP_FONT,font);
//---   
   ObjectSetInteger(chart_ID,name,OBJPROP_FONTSIZE,font_size);
//---   
   ObjectSetInteger(chart_ID,name,OBJPROP_COLOR,clr);
//---   
   ObjectSetInteger(chart_ID,name,OBJPROP_BGCOLOR,back_clr);
//---   
   ObjectSetInteger(chart_ID,name,OBJPROP_BORDER_COLOR,border_clr);
//---    (false)   (true) 
   ObjectSetInteger(chart_ID,name,OBJPROP_BACK,back);
//---     
   ObjectSetInteger(chart_ID,name,OBJPROP_STATE,state);
//---  (true)   (false)    
   ObjectSetInteger(chart_ID,name,OBJPROP_SELECTABLE,selection);
   ObjectSetInteger(chart_ID,name,OBJPROP_SELECTED,selection);
//---  (true)   (false)      
   ObjectSetInteger(chart_ID,name,OBJPROP_HIDDEN,hidden);
//---         
   ObjectSetInteger(chart_ID,name,OBJPROP_ZORDER,z_order);
//---  
   return(true);
  }
//+------------------------------------------------------------------+
//|   Close All                                                 |
//+------------------------------------------------------------------+
bool ButtonCloseAll  (const long              chart_ID=0,               // ID 
                      const string            name="ButtonCloseAll",    //  
                      const int               sub_window=0,             //  
                      const int               x=0,                      //    X 60
                      const int               y=0,                      //    Y 190
                      const int               width=90,                 //  
                      const int               height=20,                //  
                      const ENUM_BASE_CORNER  corner=CORNER_LEFT_UPPER, //    
                      const string            text="CloseAll",          // 
                      const string            font="Verdana",           // 
                      const int               font_size=10,             //  
                      const color             clr=clrBlack,             //  
                      const color             back_clr=clrGold,         //  
                      const color             border_clr=clrNONE,       //  
                      const bool              state=false,              // /
                      const bool              back=false,               //   
                      const bool              selection=false,          //   
                      const bool              hidden=true,              //    
                      const long              z_order=1)                //    
  {
//---   
   ResetLastError();
//---  
   if(!ObjectCreate(chart_ID,name,OBJ_BUTTON,sub_window,0,0))
     {
      //Print(__FUNCTION__,
      //      ":    !   = ",GetLastError());
      return(false);
     }
//---   
   ObjectSetInteger(chart_ID,name,OBJPROP_XDISTANCE,ButtonX);
   ObjectSetInteger(chart_ID,name,OBJPROP_YDISTANCE,ButtonY+25);
//---   
   ObjectSetInteger(chart_ID,name,OBJPROP_XSIZE,width);
   ObjectSetInteger(chart_ID,name,OBJPROP_YSIZE,height);
//---   ,      
   ObjectSetInteger(chart_ID,name,OBJPROP_CORNER,ButtonCorner);
//---  
   ObjectSetString(chart_ID,name,OBJPROP_TEXT,text);
//---   
   ObjectSetString(chart_ID,name,OBJPROP_FONT,font);
//---   
   ObjectSetInteger(chart_ID,name,OBJPROP_FONTSIZE,font_size);
//---   
   ObjectSetInteger(chart_ID,name,OBJPROP_COLOR,clr);
//---   
   ObjectSetInteger(chart_ID,name,OBJPROP_BGCOLOR,back_clr);
//---   
   ObjectSetInteger(chart_ID,name,OBJPROP_BORDER_COLOR,border_clr);
//---    (false)   (true) 
   ObjectSetInteger(chart_ID,name,OBJPROP_BACK,back);
//---     
   ObjectSetInteger(chart_ID,name,OBJPROP_STATE,state);
//---  (true)   (false)    
   ObjectSetInteger(chart_ID,name,OBJPROP_SELECTABLE,selection);
   ObjectSetInteger(chart_ID,name,OBJPROP_SELECTED,selection);
//---  (true)   (false)      
   ObjectSetInteger(chart_ID,name,OBJPROP_HIDDEN,hidden);
//---         
   ObjectSetInteger(chart_ID,name,OBJPROP_ZORDER,z_order);
//---  
   return(true);
  }
//+------------------------------------------------------------------+
//|                                                     |
//+------------------------------------------------------------------+
bool ButtonDelete(const long   chart_ID=0,    // ID 
                  const string name="Button") //  
  {
//---   
   ResetLastError();
//---  
   if(!ObjectDelete(chart_ID,name))
     {
      //Print(__FUNCTION__,
      //      ":    !   = ",GetLastError());
      return(false);
     }
//---  
   return(true);
  }
//---
bool CloseAll()
{
   bool error=true;
   int err,nn,OT;
   string Symb;
   while(true)
   {
      for (int g = OrdersTotal()-1; g >= 0; g--)
      {
         if (OrderSelect(g, SELECT_BY_POS))
         {
            Symb = OrderSymbol();
            if (Symb == Symbol() || AllSymbol)
            {
               OT = OrderType();
               if (OT>1) 
               {
                  bool delete1 = OrderDelete(OrderTicket());
               }
               if (OT==OP_BUY) 
               {
                  error=OrderClose(OrderTicket(),OrderLots(),NormalizeDouble(MarketInfo(Symb,MODE_BID),(int)MarketInfo(Symb,MODE_DIGITS)),3,Blue);
                  if (error) Alert(Symb,"    N ",OrderTicket(),"   ",OrderProfit(),
                                     "     ",TimeToStr(TimeCurrent(),TIME_SECONDS));
               }
               if (OT==OP_SELL) 
               {
                  error=OrderClose(OrderTicket(),OrderLots(),NormalizeDouble(MarketInfo(Symb,MODE_ASK),(int)MarketInfo(Symb,MODE_DIGITS)),3,Red);
                  if (error) Alert(Symb,"    N ",OrderTicket(),"   ",OrderProfit(),
                                     "     ",TimeToStr(TimeCurrent(),TIME_SECONDS));
               }
               if (!error) 
               {
                  err = GetLastError();
                  if (err<2) continue;
                  if (err==129) 
                  {  Comment("  ",TimeToStr(TimeCurrent(),TIME_MINUTES));
                     Sleep(5000);
                     RefreshRates();
                     continue;
                  }
                  if (err==146) 
                  {
                     if (IsTradeContextBusy()) Sleep(2000);
                     continue;
                  }
                  Comment(" ",err,"   N ",OrderTicket(),
                          "     ",TimeToStr(TimeCurrent(),TIME_MINUTES));
               }
            }
         }
      }
      int n=0;
      for (int g1 = 0; g1 < OrdersTotal(); g1++)
      {
         if (OrderSelect(g1, SELECT_BY_POS))
         {
            if (OrderSymbol() == Symbol() || AllSymbol)
            {
               OT = OrderType();
               if (OT==OP_BUY || OT==OP_SELL) n++;
            }
         }  
      }
      if (n==0) break;
      nn++;
      if (nn>10) {Alert(Symb,"      ,   ",n);return(0);}
      Sleep(1000);
      RefreshRates();
   }
   return(1);
}
//